#include "simulus.h"

int drawstuff(commands *commlist, int *count, int numnodes) {
  int colours[NUMCOLOURS] = {BLACK, BLUE, GREEN, CYAN, RED, MAGENTA, YELLOW, 
                    BLUE2, GREEN2, CYAN2, RED2, MAGENTA2, BROWN2, PINK2,
                    BLUE3, GREEN3, CYAN3, RED3, MAGENTA3, BROWN3, PINK3,
                    BLUE4, GREEN4, CYAN4, RED4, MAGENTA4, BROWN4, PINK4};
  int maxend;
  int i, j;
  int curstart, curend, curcolour, curremote;

  maxend = -1;

  drawfighead();
  // drawbox(node, start, end, colour);
  
  // draw the layout

  for(i=0;i<numnodes;i++) {
    if (commlist[i*MAXCOMM + (count[i]-1)].end > maxend) 
      maxend = commlist[i*MAXCOMM + (count[i]-1)].end; 
  }

  maxend = maxend * DRAW_FACTOR;

  drawlayout(numnodes, maxend);

  // draw the send and receives
  
  for(i=0;i<numnodes;i++) {
    //printf("count - %d\n",count[i]); 
    for(j=0;j<(count[i]-1);j++) {
      curstart = commlist[i*MAXCOMM + j].start * DRAW_FACTOR;
      curend = commlist[i*MAXCOMM + j].end * DRAW_FACTOR;
      curcolour = colours[i];
      //printf("drawing node %d command %d\n",i,j);
      drawbox(i, curstart, curend, curcolour);     
      // draw send with arrow
      if (commlist[i*MAXCOMM + j].command == SEND) {
        curremote = commlist[i*MAXCOMM + j].node;
        drawline(i, curremote, curend, curcolour);
      }
    }
  }
  return 0;
}  


int drawfighead() {
  int infd;
  ssize_t insize;
  char *tmpbuf;

  //printf("-----------------CUT FROM THIS LINE ONWARDS-----------------\n");

  infd = open(TEMPLATE, O_RDONLY);
  tmpbuf = (char*)malloc(sizeof(char));

  do {
    insize = read(infd, tmpbuf, sizeof(char));
    if (insize > 0) {
      printf("%c",*tmpbuf);
    }
  } while(insize > 0);

  close(infd);

  return 0;
}

int drawlayout(int numnodes, int end) {
  int objectcode;
  int subtype;
  int linestyle;
  int thickness;
  int pencolour;
  int fillcolour;
  int depth;
  int penstyle;
  int areafill;
  float styleval;
  int joinstyle;
  int capstyle;
  int radius;
  int forwardarrow;
  int backwardarrow;
  int npoints;
  int ulx, urx, lrx, llx;
  int uly, ury, lry, lly;
  int xstart;
  int colour;
  int i;

  objectcode = 2;
  subtype = 2;
  linestyle = 1;
  thickness = 1;
  pencolour = -1;
  fillcolour = 7;
  depth = 55;
  penstyle = 0;
  areafill = 18;
  styleval = 0.0;
  joinstyle = 0;
  capstyle = 0;
  radius = 0;
  forwardarrow = 0;
  backwardarrow = 0;
  npoints = 5;
  colour = BLACK;

  xstart = i*900;
  
  uly = 0;
  lly = end;
  ury = 0;
  lry = end;

  for(i=0;i<numnodes;i++) {
    xstart = i*900;
    ulx = xstart;
    urx = xstart + WIDTH;
    llx = xstart;
    lrx = xstart + WIDTH;
    printf("%d %d %d %d %d %d %d %d %d %f %d %d %d %d %d %d\n",
           objectcode, subtype, linestyle, thickness, pencolour, fillcolour,
           depth, penstyle, areafill, styleval, joinstyle, capstyle, radius,
           forwardarrow, backwardarrow, npoints);
    printf("%d %d %d %d %d %d %d %d %d %d\n",
           ulx, uly, urx, ury, lrx, lry, llx, lly, ulx, uly);
  }

  return 0;
}

int drawbox(int node, int start, int end, int colour) {
  int objectcode;
  int subtype;
  int linestyle;
  int thickness;
  int pencolour;
  int fillcolour;
  int depth;
  int penstyle;
  int areafill;
  float styleval;
  int joinstyle;
  int capstyle;
  int radius;
  int forwardarrow;
  int backwardarrow;
  int npoints;
  int ulx, urx, lrx, llx;
  int uly, ury, lry, lly;
  int xstart;

  objectcode = 2;
  subtype = 2;
  linestyle = 0;
  thickness = 1;
  pencolour = colour;
  fillcolour = 7;
  depth = 50;
  penstyle = 0;
  areafill = 20;
  styleval = 0.0;
  joinstyle = 0;
  capstyle = 0;
  radius = 0;
  forwardarrow = 0;
  backwardarrow = 0;
  npoints = 5;

  printf("%d %d %d %d %d %d %d %d %d %f %d %d %d %d %d %d\n",
         objectcode, subtype, linestyle, thickness, pencolour, fillcolour,
         depth, penstyle, areafill, styleval, joinstyle, capstyle, radius,
         forwardarrow, backwardarrow, npoints);
  
  xstart = node*900;
  
  ulx = xstart;
  urx = xstart + WIDTH;
  llx = xstart;
  lrx = xstart + WIDTH; 

  uly = start;
  lly = end;
  ury = start;
  lry = end;

  printf("%d %d %d %d %d %d %d %d %d %d\n",
         ulx, uly, urx, ury, lrx, lry, llx, lly, ulx, uly);
  
  return 0;
}

int drawline(int nodestart, int nodeend, int time, int colour) {
  int objectcode;
  int subtype;
  int linestyle;
  int thickness;
  int pencolour;
  int fillcolour;
  int depth;
  int penstyle;
  int areafill;
  float styleval;
  int joinstyle;
  int capstyle;
  int radius;
  int forwardarrow;
  int backwardarrow;
  int npoints;
  int xstart, ystart, xend, yend;

  int arrow_type;
  int arrow_style;
  float arrow_thickness;
  float arrow_width;
  float arrow_height;

  objectcode = 2;
  subtype = 1;
  linestyle = 0;
  thickness = 1;
  pencolour = colour;
  fillcolour = 7;
  depth = 50;
  penstyle = 0;
  areafill = -1;
  styleval = 0.0;
  joinstyle = 0;
  capstyle = 0;
  radius = -1;
  forwardarrow = 1;
  backwardarrow = 0;
  npoints = 2;

  arrow_type = 1;
  arrow_style = 1;
  arrow_thickness = 1.0;
  arrow_width = 60.0;
  arrow_height = 120.0;

  printf("%d %d %d %d %d %d %d %d %d %f %d %d %d %d %d %d\n",
         objectcode, subtype, linestyle, thickness, pencolour, fillcolour,
         depth, penstyle, areafill, styleval, joinstyle, capstyle, radius,
         forwardarrow, backwardarrow, npoints);
  
  printf("%d %d %f %f %f\n", arrow_type, arrow_style, arrow_thickness,
         arrow_width, arrow_height);

  if (nodestart > nodeend) {
    xstart = nodestart*900;
    xend = nodeend*900 + 600;
  } else {
    xstart = nodestart*900 + 600;
    xend = nodeend*900;
  }
    
  yend = time;
  ystart = time;
 
  printf("%d %d %d %d\n",
         xstart, ystart, xend, yend);
  
  return 0;
} 










